/* Blinker
   Copyright 2011-2019 Stefan Schuermans <stefan@blinkenarea.org>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef BLINKER_ADDR_H
#define BLINKER_ADDR_H

#include <string>

namespace Blinker {

/// socket address
class Addr
{
public:
  /// constructor
  Addr();

  /// virtual destructor
  virtual ~Addr();

public:
  /// return address family
  virtual int getFamily() const = 0;

  /// return port (use this function only if absolutely necessary)
  virtual int getPort() const = 0;

  /// set port (use this function only if absolutely necessary)
  virtual void setPort(int port) = 0;

  /**
   * @brief parse from string format
   * @param[in] str string format
   * @return if parsing was successful
   */
  virtual bool fromStr(const std::string &str) = 0;

  /**
   * @brief convert to string format
   * @return string format
   */
  virtual std::string toStr() const = 0;
}; // class Addr

} // namespace Blinker

#endif // #ifndef BLINKER_ADDR_H

